<?xml version='1.0' encoding='utf-8'?>
| <!DOCTYPE rfc SYSTEM "rfc2629-xhtml.ent" [
// external reference to RFCs
<!ENTITY rfc2119 SYSTEM "http://xml.resource.org/public/rfc/bibxml/reference.RFC.2119.xml">
// local reference to another doc
| ]>

// processing instructions
<?rfc toc="yes"?>
<?rfc symrefs="yes"?>
<?rfc compact="yes"?>
<?rfc subcompact="no"?>
<?rfc strict="no"?>
<?rfc rfcedstyle="yes"?>
<?rfc comments="yes"?>
<?rfc inline="yes"?>

rfc(category='info' number='2417689' consensus='false' ipr='trust200902' docName='ntof-dev-orga-02' submissionType='ntof-daq' obsoletes='' updates='' xml:lang='en' version='3' xmlns:xi='http://www.w3.org/2001/XInclude')
  front
    title n_ToF Development Workflow and Team Organisation
    author(fullname='Sylvain Fargier' initials='S.F.' role='editor' surname='Fargier')
      organization CERN
      address
        postal
          street 1, Esplanade des Particules
          code 1217
          city Meyrin
          country Switzerland
        email sylvain.fargier@cern.ch
    date(year='2019' month='April' day='1')

    keyword organisation

    abstract
      t This document describes the n_TOF development workflow and organisation.

  middle

    section
      name Introduction
      t
        | This document describes the n_TOF development workflow and organisation.

      t
        | This workflow is a lightweight version of #[xref(target="AGILE_SCRUM") Agile/Scrum],
        | still this document is #[strong not] an agile manifest or introduction, to have
        | a better understanding of what Agile/Scrum is please refer to the approriate documentation.

      // This one is a 'must' :)
      section
        name Requirements Notation
        t
          | The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
          | "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this
          | document are to be interpreted as described in BCP 14,
          | #[xref(target='RFC2119' format='default') RFC2119].

    section
      name Team
      t Here's n_TOF team leaders list, their roles and responsiblities:

      dl
        dt #[strong Jerome Lendaro]
        dd Responsible for the n_TOF DAQ technical infrastructures (i.e. electrical infrastructure, IT, local cabling, etc.).

        dt #[strong Paul Peronnard]
        dd Responsible for the DAQ manager, the purchasing, acceptance tests and operational support of the SPDevices DAQ cards.

        dt #[strong Roberto Cevenini]
        dd
          | Responsible of all the machines configuration, installation and maintenance.
          | Will ensure the operational support for the machines as well as for the network infrastructure.

        dt #[strong Sylvain Fargier]
        dd
          | Responsible for the software development and project management.

      t
        | #[strong Note:] This list is not intended to be exhaustive and lists only team members
        | that have direct reponsibilities in the n_TOF development team.

    section
      name Project Management
      t n_TOF development team #[bcp14 MUST] use #[xref(target='NTOF_JIRA') n_TOF Jira] to organise this project.

      t The #[em n_TOF Jira Main] board #[bcp14 SHOULD] be used to track the project progress.

      section
        name Releases

        t
          | A #[em release ] #[bcp14 MUST] be created for each milestone or delivery,
          | and it #[bcp14 MUST] have a #[em Release date].

        t
          | Task, Stories and Epics #[bcp14 SHOULD] be bound to one or more
          | Releases using the #[em Fix Version] attribute.

      section
        name Sprints

        t
          | The work is organized in 4 weeks (a month) sprints,
          | the content (tasks, stories) of the sprint #[bcp14 MUST] discussed during a
          | #[em Sprint Planning Meeting].

        t
          | There #[bcp14 MAY] be several Sprint Planning Meetings to get a sprint started,
          | depending on the different Releases that are foreseen (ex: n_TOF laboratory and Standalone-DAQ).

        t
          | Tasks and Stories #[bcp14 MUST NOT] be bound to a participant not
          | attending the sprint planning meeting.

        t
          | Tasks and stories #[bcp14 MUST] be estimated in story points to be embedded in a sprint,
          | refer to #[xref(target="AGILE_SCRUM") Agile/Scrum] guidelines for details.

        t
          | Since the development team is splitted accross several sections, each
          | team leader #[bcp14 MUST] organise his own dailes and ceremonies.

        t
          | Each participant #[bcp14 MUST] update the tasks and stories he has been
          | assigned to, he is responsible of his own work, and #[bcp14 SHOULD]
          | warn other team members as soon as an issue is foreseen.

      section
        name Meetings

        t
          | Project management meetings #[bcp14 SHOULD] be scheduled once a month,
          | ending the ongoing sprint and starting a new one.

        t
          | Each of those meetings #[bcp14 SHOULD] include a #[em Sprint Review],
          | a #[em Sprint Retrospective] followed by a #[em Sprint Planning] (doing 3 meetings at once, Yay !).

        section
          name Sprint Planning

          t
            | Sprint Planning meeting is the meeting where stories/tasks #[bcp14 MUST] be
            | split in achievable tasks and the sprint dashboard is created.

          t
            | Tasks and stories #[bcp14 MAY] be estimated during this meeting,
            | it is #[bcp14 RECOMMENDED] to use Planning Poker consensus based
            | technique to make those estimations (see #[xref(target="PLANNING_POKER") Planning Poker]), all team members
            | #[bcp14 SHOULD] participate.

        section
          name Sprint Review

          t
            | The Sprint Review meeting is where newly developped features are
            | demonstrated, everybody (including externals such as n_TOF or unrelated
            | people) #[bcp14 MAY] participate this review.

          t
            | Each participant #[bcp14 SHOULD] present his work to other members.

          t
            | Then the team #[bcp14 MUST] review achieved tickets and either validate
            | or reopen it, the final decision #[bcp14 SHOULD] be made by the
            | project manager.

        section
          name Sprint Retrospective

          t The sprint retrospective is a meeting where the processes and practices applied during the sprint are analyzed.

          t
            | All the team members #[bcp14 MUST] express their level of satisfaction and motivation
            | using the #[xref(target="RETRO_QUIZ") dedicated form].

          t
            | Each team member #[bcp14 MUST] write three topics that are worth
            | noticing for him during the sprint (either good or bad).

          t
            | A review of the actions identified in the previous sprint #[bcp14 MUST] take place.

        section
          name Daily Scrums

          t It’s the time for team members to discuss in a peer-to-peer way.

          t
            | Due to the specificities of this team, each team-leader #[bcp14 SHOULD]
            | organise his own dailies, isolated team-leaders may not do daily scrums,
            | still it is highly #[bcp14 RECOMMENDED] to organise scrums as often as
            | possible with other team members.

          t
            | Team leaders #[bcp14 MUST] sumarise and report those dailies and
            | progress to the project manager at least once a week.

          t
            | The Daily Scrum #[bcp14 MUST] take place everyday and last less than
            | 15 minutes. Every team member presence is #[bcp14 REQUIRED],
            | having a 2 minutes time slot to explain :

          ul
            li What he did yesterday
            li What he is going to do today
            li What problems he encountered

          t Any long discussion #[bcp14 MUST] be cut short and discussed after the meeting.

    section
      name Contributors
      // Optional section to mention contributors

  back

    references
      name References
      references
        name Normative References
        | &rfc2119;

      references
        name Informative References

      references
        name URL References
        reference(anchor='NTOF_JIRA' target='https://its.cern.ch/jira/browse/NTOFNEWDAQ')
          front
            title n_TOF development team Jira project management
            author #[organization CERN]
            date(year='2019')
        reference(anchor='RETRO_QUIZ' target='http://apc-dev.web.cern.ch/docs/drafts/current/ntof-dev-organisation/RETRO_QUIZ.pdf')
          front
            title Retro Quiz reference
            author #[organization CERN]
            date(year='2019')

        reference(anchor='AGILE_SCRUM' target='https://www.mountaingoatsoftware.com/agile/scrum')
          front
            title Agile Scrum introduction
            author #[organization Mountain Goat Software]
            date(year='2019')
        reference(anchor='PLANNING_POKER' target='https://www.mountaingoatsoftware.com/agile/planning-poker')
          front
            title Planning Poker introduction
            author #[organization Mountain Goat Software]
            date(year='2019')

    section
      name Change Log
      dl
        dt 01
        dd First version

        dt 02
        dd Using a more agile oriented methodology

    //- section
    //-   name Open Issues
    //-   t A list of open issues regarding this document
